#include<stdio.h>
#include<time.h>

typedef unsigned char u_char;
typedef unsigned short u_short;
typedef unsigned int u_int;
/* 4 bytes IP address */
typedef struct ip_address{
    u_char byte1;
    u_char byte2;
    u_char byte3;
    u_char byte4;
}ip_address;

/* tempstruct header*/
typedef struct period_e{
    u_int ips;             // source ip
    u_int ipd;             // destination ip
    u_short ports;         // Source port
    u_short portd;         // Destination port
    u_char proto;          // higher protocol
    u_int size;            // sum of packet sizes
    u_int packets;         // amount of packets
}period_e;

int main(int argc,char * argv[])
{
	unsigned int i,amount,time;
	struct tm *ltime;
	char timestr[256];
	if(argc < 2){printf("specify the file to recognize\n"); return 0;}
	char s[256]; for(i = 0;argv[1][i] != 0;i++)s[i] = argv[1][i]; s[i] = '_'; s[i+1] = 0;
	FILE *f,*g;
	period_e p;
	if(NULL == (f = fopen(argv[1],"rb"))){printf("can't open %s for reading\n",argv[1]);return 0;}
	g = fopen(s,"wb");
	printf("size of struct = %d \n",sizeof(period_e));
	time = 0; amount = 0;
	fread(&time,1,4,f); fread(&amount,1,2,f);
	while(!feof(f))
	{
		ltime = localtime((long *)&time);
		strftime( timestr, sizeof timestr, "%y-%m-%d %H:%M:%S", ltime);
		fprintf(g,"%s\n",timestr);
		for(i = 0;i < amount;i++)
		{
			fread(&p,1,sizeof(period_e),f);
			fprintf(g,"%03d.%03d.%03d.%03d\t%-5d\t",((ip_address *)&p.ips)->byte1,
				((ip_address *)&p.ips)->byte2,((ip_address *)&p.ips)->byte3,
				((ip_address *)&p.ips)->byte4,p.ports);
			fprintf(g,"%03d.%03d.%03d.%03d\t%-5d\t",((ip_address *)&p.ipd)->byte1,
				((ip_address *)&p.ipd)->byte2,((ip_address *)&p.ipd)->byte3,
				((ip_address *)&p.ipd)->byte4,p.portd);
			fprintf(g,"%d\t%d\t%d\n",p.proto,p.size,p.packets);
		}
	time = 0; amount = 0;
	fread(&time,1,4,f); fread(&amount,1,2,f);
	}
	fcloseall();
	return 0;
}